# How to contribute

Thanks for taking the time to contribute! If you want to contribute, but are not sure where to start consider taking a look at our "help wanted" issues.

## Do you want to contribute?
- Check the list of open issues. Either assign an existing issue to yourself, or create a new one that you would like work on and discuss your ideas and use cases.
- Fork the repository on GitHub
- Create a topic branch from where you want to base your work. This is usually master.
- Make commits of logical units with explanatory commit messages.
- Push your changes to a topic branch in your fork of the repository.
- Open a new GitHub pull request with the code changes.
- Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.
- Your contribution requires approval from one of the trusted committers.

## Did you find a bug?
- Reporting bugs is one of the best ways to contribute. Be sure the bug was not already reported by searching on GitHub under Issues.
- If you're unable to find an open issue addressing the problem, open a new one. Be sure to include a title and clear description, as much relevant information as possible, and a code sample or an executable test case demonstrating the expected behavior that is not occurring.

## Did you write a patch that fixes a bug?
- Open a new GitHub pull request with the patch.
- Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.
